#include <stdio.h>
#include <math.h>
#define MaxN 502

long n, m, a [MaxN][MaxN], Volume, Area;

void Input ()
{
	FILE *in;
	long i, j;

	in = fopen ("zad3.dat", "r");
	fscanf (in, "%ld %ld", &n, &m);
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			fscanf (in, "%ld", &a [i][j]);
	fclose (in);
}

void Output ()
{
	FILE *out;

	out = fopen ("zad3.res", "w");
	fprintf (out, "%ld %ld\n", Volume, Area);
	fclose (out);
}

void Solve ()
{
	long i, j;

	Volume = 0;
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			Volume = Volume + a [i][j];

	for (i = 0; i <= n; i++)
	{
		a [i][0] = 0;
		a [i][m + 1] = 0;
	}
	for (j = 0; j <= m; j++)
	{
		a [0][j] = 0;
		a [n + 1][j] = 0;
	}
	Area = 0;
	for (i = 0; i <= n; i++)
		for (j = 0; j <= m; j++)
		{
			if (a [i][j] > 0)
				Area = Area + 2;
			Area = Area + abs (a [i][j] - a [i + 1][j]) + abs (a [i][j] - a [i][j + 1]);
		}
}

int main ()
{
	Input ();
	Solve ();
	Output ();
	return 0;
}
